/* Generated by Together */
import java.util.*;
import java.io.*;

public class Park {
	private final int HEIGTH = 20;
	private final int WIDTH = 20;
	private final int MAX_WANDERERS = 10;
	
	private Wanderer[] wanderers = new Wanderer[MAX_WANDERERS];
    private int count = 0;

	private String message = "Welcome to ParkGarden";  // message à afficher à l'utilisateur au draw()

	private int occupied(int x, int y) {
		for(int k = 0; k<count ; k++) {
			if(wanderers[k].at(x,y)) return k;
        }
		return -1;
	}

	public void draw() {
		clearConsole();
		for(int i = 0 ; i<=HEIGTH ; i++) {
            for(int j = 0 ; j<=WIDTH ; j++) {
				int iTraveler = occupied(i,j);
            	if(iTraveler >= 0)
					System.out.print(iTraveler);
				else
					System.out.print(" ");
        	}
		System.out.println();
        }
    }

    public void run() throws IOException {
        String line="";
		int n, posx, posy;
		BufferedReader input = new BufferedReader(
						new InputStreamReader(System.in));
		while(true) {
			System.out.println(message);
			try {
	            line = input.readLine();
				if(line.startsWith("stop")) break;
				String[]  command = line.split(" ");
	            if(command.length == 3 && command[0].equals("add")) {
	                posx = Integer.parseInt(command[1]);
	                posy = Integer.parseInt(command[2]);
					this.addWanderer(posx, posy);
	            } else if(command.length == 4 && command[0].equals("move")) {
	                n = Integer.parseInt(command[1]);
	                posx = Integer.parseInt(command[2]);
	                posy = Integer.parseInt(command[3]);
					this.moveWanderer(n,posx, posy);
	            } else {
					System.out.println("Unrecognized command: "+line);
	            }
            } catch (Exception e) {
				this.message = "Commands are : \n "
                    		  +"  add x y (where x and y are the positions),\n"
                    		  +"  move n x y (where n is the index of the traveler and x,y the movement offset),\n"
                              +"  stop\n";
            }
            this.draw();
        }
    }

	private boolean in(int posx, int posy) {
		return posx<WIDTH && posx>=0 && posy>=0 && posy<HEIGTH;
	}

    public void addWanderer(int posx,int posy) {
		if (count >= MAX_WANDERERS) {
			message = "Too many wanderers";
		} else if (in(posx, posy)) {
			wanderers[count] = new Wanderer(posx, posy);
			count++;
		} else {
			message = "Wanderer out of bounds";
		}
    }

    public void moveWanderer(int n, int posx, int posy) {
		if(n<0 || n>=count) {
			message = "Wanderer does not exist";
		} else {
			Wanderer t = wanderers[n];
			if(t.move_allowed(posx, posy, WIDTH, HEIGTH))
				t.move(posx, posy);
			else
				message = "Move out of bounds";
		}
    }

 	private void clearConsole() {
		int i = 100;
		while(i-- > 0) System.out.println();
    }

    public static void main(String[] args) throws Exception {
       Park park = new Park();
       park.run();
    }
}
